
/*
 * M"uhlenbein's (ICGA'91) f7, attributed to Schwefel (1977)
 *
 * global optimum at (forall i) x_i = 420.968; value: -4189.8289
 * local optima same place except (exists j) x_j = -302.525
 *
 */

#include <math.h>
#include "GAbench.h"

#ifdef __STDC__
REAL msb_f7(REAL* x, int n)
#else
REAL msb_f7(x,n)
REAL *x;
int n;
#endif
{
	register int i;
	register double sum;

	for (sum = 0.0, i = 0; i < n; i++, x++)
		sum += - *x * sin(sqrt(fabs(*x)));
	return(sum);
}

